# -------------------------------------------------VARIABLES ------------------------------------------------

variables:
  API_IMAGE: $DOCKER_REGISTRY/$REPO_NAME_API:production
  FRONT_IMAGE: $DOCKER_REGISTRY/$REPO_NAME_FRONT:production

  PROJECT_ID:  $CI_PROJECT_ID
  PROJECT_NAME:  $CI_PROJECT_NAME
  #----> $ENVIRONMENT (production | staging)


# ----------------------------------- MULTI-PROJECT PIPELINE:  TRIGGERED FROM OTHERS PROJECT ---------------------------------------------

stages:
  - testing
  - dockerizing
  - merge
  - deploy
  - destroy


include:
  - local: "/ci-templates/trigger-modules/.gitlab-ci-deploy-production.yml"
    rules:
      - if: $CI_PIPELINE_SOURCE == "pipeline"


# ------------------------------------------- PARENT-CHILD PIPELINES: TRIGGERED PUSH ------------------------------------------------


default:
  tags:
    - fast

testing:
  stage: testing
  trigger:
    include:  "/ci-templates/local-modules/.gitlab-ci-test.yml"
    strategy: depend
  rules: &change-rules
    - if: $CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_BRANCH == "staging"
      changes:
        - environments/staging/**/*
        - environments/production/**/*
        - modules/**/*

dockerizing-and-merge:
  stage: dockerizing
  trigger:
    include: "/ci-templates/local-modules/.gitlab-ci-dockerize.yml"
    strategy: depend
  needs:
    - job: testing
      optional: true
  rules: *change-rules


optional-staging-network:
  stage: merge
  trigger:
    include: "/ci-templates/local-modules/.gitlab-ci-optional.yml"
  rules:
    - if: $CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_BRANCH == "production"


#debug-post-1:
#  stage: .post
#  script: echo "nothing"
#  variables:
#    CI_DEBUG_TRACE: "false"
